local require = GLOBAL.require
local STRINGS = GLOBAL.STRINGS
local Ingredient = GLOBAL.Ingredient
local RECIPETABS = GLOBAL.RECIPETABS
local Recipe = GLOBAL.Recipe
local TECH = GLOBAL.TECH

local shieldRecipe = AddRecipe("shield", {Ingredient("boards", 2), Ingredient("rope", 1) }, GLOBAL.RECIPETABS.WAR, GLOBAL.TECH.SCIENCE_ONE, nil, nil, nil, nil, "wonil", "images/inventoryimages/shield.xml" )
shieldRecipe.sortkey = -9001

local defender_auras = {}

AddPrefabPostInit("wonil", function(inst)
    if not GLOBAL.TheWorld.ismastersim then
        return
    end
    defender_auras[inst.GUID] = { range = 15, absorb_per = 0.10 }
    inst.OnDespawn = function(inst)
        defender_auras[inst.GUID] = nil
    end
end)
  
AddPlayerPostInit(function(inst)
    if inst.components.combat == nil then
        return
	end
    if not GLOBAL.TheWorld.ismastersim then
        return
    end
    local old_ga = inst.components.combat.GetAttacked
    inst.components.combat.GetAttacked = function(self, attacker, damage, weapon, stimuli)
			if damage ~= nil then
				for k, v in pairs(defender_auras) do
					local p = GLOBAL.Ents[k]
					if p:IsNear(self.inst, v.range) then
						damage = damage * (1 - v.absorb_per)
						break
					end
				end
			end
        return old_ga(self, attacker, damage, weapon, stimuli)
    end
end)

RemapSoundEvent( "dontstarve/characters/wonil/death_voice", "wonil/sound/death_voice" )
RemapSoundEvent( "dontstarve/characters/wonil/hurt", "wonil/sound/hurt" )
RemapSoundEvent( "dontstarve/characters/wonil/talk_LP", "wonil/sound/talk_LP" )
RemapSoundEvent( "dontstarve/characters/wonil/emote", "wonil/sound/emote" )
RemapSoundEvent( "dontstarve/characters/wonil/yawn", "wonil/sound/yawn" )
RemapSoundEvent( "dontstarve/characters/wonil/eye_rub_vo", "wonil/sound/eye_rub_vo" )
RemapSoundEvent( "dontstarve/characters/wonil/pose", "wonil/sound/pose" )

AddMinimapAtlas("images/map_icons/wonil.xml")
