local assets=
{
    Asset("ANIM", "anim/shield.zip"),
    Asset("ANIM", "anim/swap_shield.zip"),
  
    Asset("ATLAS", "images/inventoryimages/shield.xml"),
    Asset("IMAGE", "images/inventoryimages/shield.tex"),
}

local prefabs = 
{}

local function OnBlocked(owner) 
    owner.SoundEmitter:PlaySound("dontstarve/wilson/hit_armour")
end


local function OnEquip(inst, owner)
    owner.AnimState:OverrideSymbol("swap_object", "swap_shield", "swap_shield")
    owner.AnimState:Show("ARM_carry")
    owner.AnimState:Hide("ARM_normal")
	inst:ListenForEvent("blocked", OnBlocked, owner)
        owner:AddTag("shielded")
end
  
local function OnUnequip(inst, owner)
    owner.AnimState:Hide("ARM_carry")
    owner.AnimState:Show("ARM_normal")
	inst:RemoveEventCallback("blocked", OnBlocked, owner)
        owner:RemoveTag("shielded")
end
 
local function fn()
  
    local inst = CreateEntity()
 
    inst.entity:AddTransform()
    inst.entity:AddAnimState()
    inst.entity:AddNetwork()
     
    MakeInventoryPhysics(inst)   
      
    inst.AnimState:SetBank("shield")
    inst.AnimState:SetBuild("shield")
    inst.AnimState:PlayAnimation("idle")
 
    inst:AddTag("dull")
	inst:AddTag("shield")
	inst:AddTag("shielded")
	
	inst.foleysound = "dontstarve/movement/foley/woodarmour"
 
    if not TheWorld.ismastersim then
        return inst
    end
 
    inst.entity:SetPristine()
     
    inst:AddComponent("weapon")
    inst.components.weapon:SetDamage(20)
	
	inst:AddComponent("armor")
	inst.components.armor:InitCondition(TUNING.ARMOR_FOOTBALLHAT*2, 0.90)
	
    inst:AddComponent("inspectable")
      
    inst:AddComponent("inventoryitem")

    inst.components.inventoryitem.imagename = "shield"
    inst.components.inventoryitem.atlasname = "images/inventoryimages/shield.xml"
      
    inst:AddComponent("equippable")
    inst.components.equippable:SetOnEquip( OnEquip )
    inst.components.equippable:SetOnUnequip( OnUnequip )
	inst.components.equippable.walkspeedmult = 0.95	
	
	--inst.components.combat.min_attack_period = 0.6
	
    MakeHauntableLaunch(inst)
	
    return inst
end

STRINGS.NAMES.SHIELD = "Shield"
STRINGS.CHARACTERS.GENERIC.DESCRIBE.SHIELD = "Sturdy."
STRINGS.CHARACTERS.WONIL.DESCRIBE.SHIELD = "A strong shield is all you need to protect those you love."
STRINGS.RECIPE_DESC.SHIELD = "The best defense is a good defense."

return  Prefab("common/inventory/shield", fn, assets, prefabs) 