
local MakePlayerCharacter = require "prefabs/player_common"

local assets = {
    Asset("SCRIPT", "scripts/prefabs/player_common.lua"),
    Asset( "ANIM", "anim/wonil.zip" ),
    Asset( "ANIM", "anim/ghost_wonil_build.zip" ),
}

local prefabs = {}
local start_inv = {"shield",
}

local function onbecamehuman(inst)
	inst.components.locomotor:SetExternalSpeedMultiplier(inst, "wonil_speed_mod", 1)
end

local function onbecameghost(inst)
   inst.components.locomotor:RemoveExternalSpeedMultiplier(inst, "wonil_speed_mod")
end


local function onload(inst)
    inst:ListenForEvent("ms_respawnedfromghost", onbecamehuman)
    inst:ListenForEvent("ms_becameghost", onbecameghost)

    if inst:HasTag("playerghost") then
        onbecameghost(inst)
    else
        onbecamehuman(inst)
    end
end

local function laststand(inst)

	if inst.components.health.currenthealth > (0) and inst.components.health.currenthealth <= (100) then
		inst.components.combat.damagemultiplier = 1.25
	elseif  inst.components.health.currenthealth > (100) and inst.components.health.currenthealth <= (250) then
		inst.components.combat.damagemultiplier = 0.8
	end
end



local common_postinit = function(inst) 
	inst.MiniMapEntity:SetIcon( "wonil.tex" )
	inst:AddTag("wonil")
end


local master_postinit = function(inst)

	inst.soundsname = "wonil"
	
	inst.components.health:SetMaxHealth(250)
	inst.components.hunger:SetMax(150)
	inst.components.sanity:SetMax(100)
    inst.components.combat.damagemultiplier = 0.8
	inst.components.hunger.hungerrate = 1.20 * TUNING.WILSON_HUNGER_RATE
	inst.components.locomotor.runspeed = (TUNING.WILSON_RUN_SPEED * 1.0)
	inst.components.locomotor.walkspeed = (TUNING.WILSON_WALK_SPEED * 1.0)
	--inst.components.sanity.dapperness = (TUNING.DAPPERNESS_LARGE + 3)
	inst.Transform:SetScale(1.02, 1.02, 1.02)
	
	inst.components.eater.stale_hunger = TUNING.WICKERBOTTOM_STALE_FOOD_HUNGER
    inst.components.eater.stale_health = TUNING.WICKERBOTTOM_STALE_FOOD_HEALTH
	
	--Ranged weapons and Melee weapon Damage Modifier
	local _cd = inst.components.combat.CalcDamage
	inst.components.combat.CalcDamage = function(self, target, weapon, multiplier)
    multiplier = multiplier or 1
    local weprange = weapon and weapon.components.weapon.hitrange or self:GetAttackRange()
    	if weprange < 4 then
        	multiplier = multiplier * 1
    	else
        	multiplier = multiplier * 0.8
    	end
    	return _cd(self, target, weapon, multiplier)
	end
	
	inst:ListenForEvent("healthdelta", function(inst) laststand(inst) end )
	laststand(inst)

	inst.OnLoad = onload
    inst.OnNewSpawn = onload
	
end

return MakePlayerCharacter("wonil", prefabs, assets, common_postinit, master_postinit, start_inv)